package com.danitheskunk.skunkworks.backends.gl;

public class FilterColorThreshold extends Filter {
	private static final String fragmentSource = """
		#version 450
		layout(location = 1) in vec2 texCoord;
		layout(binding = 0) uniform sampler2D tex;
		out vec4 color;
		void main() {
			vec4 col = texture(tex, texCoord);
			/*
			if(col.r > 0.5) 
				col.r = 1.0;
			else
				col.r = 0.0;
			if(col.g > 0.5) 
				col.g = 1.0;
			else
				col.g = 0.0;
			if(col.b > 0.5) 
				col.b = 1.0;
			else
				col.b = 0.0;
			*/
			if(col.r > 0.5 && col.g < 0.5 && col.b < 0.5) {
				col.r = 1.0;
				col.g = 0.0;
				col.b = 0.0;
			} else if(col.r + col.g + col.b > 2.5) {
				col.r = 1.0;
				col.g = 1.0;
				col.b = 1.0;
			} else {
				col.r = 0.0;
				col.g = 0.0;
				col.b = 0.0;
			}
			if(col.a > 0.0) {
				color = col;
			}
		}
		""";
	private static final String vertexSource = """
		#version 450
		layout(location = 0) in vec2 pos;
		layout(location = 1) out vec2 out_texCoord;
		void main() {
			gl_Position = vec4(pos, 0.0f, 1.0f);
			out_texCoord = vec2(pos.x * 0.5 + 0.5, pos.y * 0.5 + 0.5);
		}
		""";
	public FilterColorThreshold(Framebuffer input) {
		super(input, new Program(vertexSource, fragmentSource), false);
	}
}
